//NameTag by DarkyBenji
--Feature inspired from v2, recreated for v1

--Thanks to Tyron for the Colorskin
local colLookup = {[SKINCOLOR_WHITE] = "\x80",	[SKINCOLOR_SILVER] = "\x80",	[SKINCOLOR_SLATE] = "\x80",		[SKINCOLOR_ULTRAVIOLET] = "\x81",	[SKINCOLOR_PURPLE] = "\x81",	[SKINCOLOR_FUCHSIA] = "\x81",		[SKINCOLOR_POPCORN] = "\x82",	[SKINCOLOR_QUARRY] = "\x82",	[SKINCOLOR_YELLOW] = "\x82",	[SKINCOLOR_MUSTARD] = "\x82",	[SKINCOLOR_CROCODILE] = "\x82",	[SKINCOLOR_OLIVE] = "\x82",		[SKINCOLOR_LIME] = "\x83",	[SKINCOLOR_HANDHELD] = "\x83",	[SKINCOLOR_MOSS] = "\x83",	[SKINCOLOR_CAMOUFLAGE] = "\x83",	[SKINCOLOR_ROBOHOOD] = "\x83",	[SKINCOLOR_MINT] = "\x83",	[SKINCOLOR_GREEN] = "\x83",	[SKINCOLOR_PINETREE] = "\x83",	[SKINCOLOR_ALGAE] = "\x83",	[SKINCOLOR_PLAGUE] = "\x83",	[SKINCOLOR_EMERALD] = "\x83",	[SKINCOLOR_SWAMP] = "\x83",	[SKINCOLOR_DREAM] = "\x83",		[SKINCOLOR_PERIWINKLE] = "\x84",	[SKINCOLOR_BLUE] = "\x84",	[SKINCOLOR_BLUEBERRY] = "\x84",	[SKINCOLOR_NOVA] = "\x84",		[SKINCOLOR_CINNAMON] = "\x85",	[SKINCOLOR_RUBY] = "\x85",	[SKINCOLOR_RASPBERRY] = "\x85",	[SKINCOLOR_CHERRY] = "\x85",	[SKINCOLOR_RED] = "\x85",	[SKINCOLOR_CRIMSON] = "\x85",	[SKINCOLOR_MAROON] = "\x85",	[SKINCOLOR_FLAME] = "\x85",	[SKINCOLOR_SCARLET] = "\x85",	[SKINCOLOR_KETCHUP] = "\x85",		[SKINCOLOR_GREY] = "\x86",	[SKINCOLOR_NICKEL] = "\x86",	[SKINCOLOR_BLACK] = "\x86",	[SKINCOLOR_SKUNK] = "\x86",	[SKINCOLOR_JET] = "\x86",		[SKINCOLOR_DAWN] = "\x87",	[SKINCOLOR_SUNSET] = "\x87",	[SKINCOLOR_CREAMSICLE] = "\x87",	[SKINCOLOR_ORANGE] = "\x87",	[SKINCOLOR_PUMPKIN] = "\x87",	[SKINCOLOR_ROSEWOOD] = "\x87",	[SKINCOLOR_BURGUNDY] = "\x87",	[SKINCOLOR_TANGERINE] = "\x87",		[SKINCOLOR_CARIBBEAN] = "\x88",	[SKINCOLOR_AZURE] = "\x88",	[SKINCOLOR_AQUA] = "\x88",	[SKINCOLOR_TEAL] = "\x88",	[SKINCOLOR_CYAN] = "\x88",	[SKINCOLOR_JAWZ] = "\x88",	[SKINCOLOR_CERULEAN] = "\x88",	[SKINCOLOR_NAVY] = "\x88",	[SKINCOLOR_SAPPHIRE] = "\x88",		[SKINCOLOR_PASTEL] = "\x89",	[SKINCOLOR_MOONSLAM] = "\x89",	[SKINCOLOR_DUSK] = "\x89",	[SKINCOLOR_TOXIC] = "\x89",	[SKINCOLOR_MAUVE] = "\x89",	[SKINCOLOR_LAVENDER] = "\x89",	[SKINCOLOR_BYZANTIUM] = "\x89",	[SKINCOLOR_POMEGRANATE] = "\x89",		[SKINCOLOR_GOLD] = "\x8A",	[SKINCOLOR_ROYAL] = "\x8A",	[SKINCOLOR_BRONZE] = "\x8A",	[SKINCOLOR_COPPER] = "\x8A",	[SKINCOLOR_THUNDER] = "\x8A",		[SKINCOLOR_ARTICHOKE] = "\x8B",	[SKINCOLOR_VOMIT] = "\x8B",	[SKINCOLOR_GARDEN] = "\x8B",	[SKINCOLOR_TEA] = "\x8B",	[SKINCOLOR_PISTACHIO] = "\x8B",		[SKINCOLOR_PIGEON] = "\x8C",	[SKINCOLOR_PLATINUM] = "\x8C",	[SKINCOLOR_STEEL] = "\x8C",		[SKINCOLOR_FAIRY] = "\x8D",	[SKINCOLOR_SALMON] = "\x8D",	[SKINCOLOR_PINK] = "\x8D",	[SKINCOLOR_ROSE] = "\x8D",	[SKINCOLOR_BRICK] = "\x8D",	[SKINCOLOR_LEMONADE] = "\x8D",	[SKINCOLOR_BUBBLEGUM] = "\x8D",	[SKINCOLOR_LILAC] = "\x8D",		[SKINCOLOR_SEPIA] = "\x8E",	[SKINCOLOR_BEIGE] = "\x8E",	[SKINCOLOR_WALNUT] = "\x8E",	[SKINCOLOR_BROWN] = "\x8E",	[SKINCOLOR_LEATHER] = "\x8E",	[SKINCOLOR_RUST] = "\x8E",	[SKINCOLOR_WRISTWATCH] = "\x8E",	[SKINCOLOR_PEACH] = "\x8F",	[SKINCOLOR_CARAMEL] = "\x8F",	[SKINCOLOR_CREAM] = "\x8F",}
local starttime = 9*TICRATE + (3*TICRATE/4)
local FRACUNIT = FRACUNIT
local INT16_MAX = INT16_MAX
local NAME_MAXDIST = 320*FRACUNIT

rawset(_G, "Nametags", "v2")
--------------------------------------------------------------------------------
//CVAR
--------------------------------------------------------------------------------
local nametagactive = CV_RegisterVar({
	name = "nametag",
	defaultvalue = "On",
	flags = nil,
	possiblevalue = CV_OnOff
})

local nametagclan = CV_RegisterVar({
	name = "nametag_clan",
	defaultvalue = "On",
	flags = nil,
	possiblevalue = CV_OnOff
})

local nametagicon = CV_RegisterVar({
	name = "nametag_icon",
	defaultvalue = "Off",
	flags = nil,
	possiblevalue = CV_OnOff
})

local nametagstats = CV_RegisterVar({
	name = "nametag_stats",
	defaultvalue = "Restat",
	flags = nil,
	possiblevalue = {Off = 0, Restat = 1, Always = 2}
})

local nametagdist = CV_RegisterVar({
	name = "nametag_dist",
	defaultvalue = "160",
	flags = CV_FLOAT,
	possiblevalue = {MIN = 0, MAX = NAME_MAXDIST}
})

local nametagcap = CV_RegisterVar({
	name = "nametag_cap",
	defaultvalue = "4",
	flags = nil,
	possiblevalue = CV_Natural
})

local nametagsmall = CV_RegisterVar({
	name = "nametag_small",
	defaultvalue = "Off",
	flags = nil,
	possiblevalue = CV_OnOff
})

local nametagadjust = CV_RegisterVar({
	name = "nametag_adjust",
	defaultvalue = "0",
	flags = nil,
	possiblevalue = {MIN = -160, MAX = 160}
})

local nametagdynamic = CV_RegisterVar({
	name = "nametag_dynamic",
	defaultvalue = "On",
	flags = nil,
	possiblevalue = CV_OnOff
})

local nametagdebug = CV_RegisterVar({
	name = "nametag_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP|CV_SHOWMODIF,
	possiblevalue = CV_OnOff
})

--First, we set things up
local dTags = {}
local function CanIhidemyTag(p)
	if p.kartstuff[k_hyudorotimer] 
	or p.mo.flags2 & MF2_DONTDRAW
	or p.elim_rejoinEnd //???
	then return false else return true end
end
local function CanIkillmyTag(p)
	return p.exiting 
	or p.playerstate == PST_DEAD 
	or p.mo.health == 0 
	or p.spectator 
end

addHook("ThinkFrame", function()
	for player in players.iterate do
		if not player.mo or not player.mo.valid continue end 
		
		if player.startag == nil then player.startag = 0 end
		
		if not player.mo.taginit then
			table.insert(dTags, {mo = player.mo, visual = true, startag = player.startag})
			player.mo.taginit = true
		end

		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			if nametag.mo and nametag.mo.valid then
				if nametag.mo == player.mo then
					--Hide the Tag but do not remove it yet
					nametag.visual = CanIhidemyTag(player)
					
					--Now you can remove it, there's no need to keep it
					if CanIkillmyTag(player) then
						dTags[i] = 01
						table.remove(dTags, i)
					end
				end
			else
				dTags[i] = 01
				table.remove(dTags, i)
			end
		end
		
	end
end)

--Shoutout to Lat for the ScreenCoords
--With alot of edit because of god damn no-green-screen, fov, other bullshit
local function LatHud_ScreenCoords(v, p, c, mx, my, mz)
	local camx, camy, camz, camangle, camaiming
	if p.awayviewtics then
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase then
		camx = c.x
		camy = c.y
		camz = c.z
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz-20*FRACUNIT
		camangle = p.mo.angle
		camaiming = p.aiming
	end

	-- Lat: I'm actually very lazy so mx can also be a mobj!
	if type(mx) == "userdata" and mx.valid
		my = mx.y
		mz = mx.z
		mx = mx.x	-- life is easier
	end

	local x = camangle-R_PointToAngle2(camx, camy, mx, my)

	local distfact = cos(x)
	if not distfact then
		distfact = 1
	end -- MonsterIestyn, your bloody table fixing...

	local resX = 160 - (nametagadjust.value)
	if splitscreen == 1 then 
		resX = $-65
	end
	local resY = 160 - (nametagadjust.value)
	if splitscreen == 1 then 
		resY = $+65
	end

	if x > ANGLE_90 or x < ANGLE_270 then
		return -9, -9, 0
	else
		x = FixedMul(tan(x, true), resX<<FRACBITS)+160<<FRACBITS
	end

	local y = camz-mz
	--print(y/FRACUNIT)
	y = FixedDiv(y, FixedMul(distfact, R_PointToDist2(camx, camy, mx, my)) or 1)
	y = (y*resY)+(100<<FRACBITS)
	y = y+tan(camaiming, true)*resY

	return x, y
end

-- of course, fickle's replay system kind of sucks so splitscreen there will need an ADDITIONAL HACK.
-- thank you fickle.
local splitplayers = {}
local function splitnum(p)
	for i = 1, #splitplayers do
		if splitplayers[i] == p
			return i-1
		end
	end
end

--And now the render
local function TagNames(v, player, camera)
	--you don't need nametag lua if you have a custom exe that do the job for you (but still, get the lua for the other players)
	--if CV_FindVar("kartnametag") and CV_FindVar("kartnametag").value then return end
	if nametagactive.value and (player and player.mo and player.mo.valid) then
		splitplayers[#splitplayers+1] = player
		local tagnum = 0
		for i = #dTags,1,-1 do
			local nametag = dTags[i]
			if nametag.mo and nametag.mo.valid and nametag.mo.player then
			
				local p = player.mo
				local n = nametag.mo
				local np = nametag.mo.player
			
				local maxdist = min(nametagdist.value, NAME_MAXDIST)*10
				local thisdist = R_PointToDist2(n.x, n.y, camera.x, camera.y)

				local posz = n.z + n.height
				local basex,basey = LatHud_ScreenCoords(v, player, camera, n.x, n.y, posz)
				local baselimitx, baselimity = UINT8_MAX, UINT8_MAX

				-- ready splitscreen stuff
				local splitflags = 0
				if splitscreen == 1 then -- 2p
					basey = $/2
					baselimity = $/2
					if splitnum(player)
						splitflags = V_SPLITSCREEN|V_SNAPTOBOTTOM	
					end
				elseif splitscreen > 1 then -- 3p / 4p
					basex = $/2
					basey = $/2
					baselimitx = $/2
					baselimity = $/2
					if splitnum(player) == 1
						splitflags = V_HORZSCREEN
					elseif splitnum(player) == 2
						splitflags = V_SPLITSCREEN|V_SNAPTOBOTTOM
					elseif splitnum(player) == 3
						splitflags = V_SPLITSCREEN|V_HORZSCREEN|V_SNAPTOBOTTOM
					end
				end
				
				if encoremode then 
					if splitscreen > 1 then
						basex = 160<<FRACBITS - $
					else
						basex = 320<<FRACBITS - $
					end
				end
				
				local namex = (basex>>FRACBITS)
				local namey = (basey>>FRACBITS)
				
				local transtag = 0
				if nametagdynamic.value
					if (thisdist > (maxdist*9/10))
						transtag = V_80TRANS
					elseif (thisdist > (maxdist*4/5)) 
						transtag = V_60TRANS
					elseif (thisdist > (maxdist*7/10))
						transtag = V_40TRANS
					elseif (thisdist > (maxdist*3/5))
						transtag = V_20TRANS
					end
				else
					transtag = V_HUDTRANS
				end
				
				local iconx, ficonx = 0, 0
				if nametagicon.value then
					iconx = 14
					ficonx = iconx*FRACUNIT
					if nametagsmall.value or splitscreen > 1 then
						iconx, ficonx = $/2, $/2
					end
				end
				
				local cmap = v.getColormap(-1, n.color)
			
				if (n != p and leveltime > starttime) --display Other Player tag, but first...
				or (n == p and (leveltime > 0 and leveltime < 130)) --Let's display your tag before the countdown
				or (nametagdebug.value) --Or Just display all of them because yay Debug
					if (thisdist < maxdist)
						if namex < baselimitx and namey < baselimity and tagnum < nametagcap.value --plz						
							tagnum = $+1						
							if nametag.visual
								--Line Pointing
								local nametagscale = FRACUNIT
								if nametagsmall.value or splitscreen > 1 then nametagscale = $/2 end
								
								v.drawScaled(basex, basey, nametagscale, v.cachePatch("NTLINEP"), splitflags|transtag, cmap)
										
								--Icon
								if nametagicon.value 
									v.drawScaled(basex+(8*nametagscale), basey-(16*nametagscale), nametagscale, v.cachePatch(skins[n.skin].facemmap), splitflags|transtag, cmap)
								end
								
								--Color Name
								local colorname = colLookup[np.skincolor or 1]
								
								--Name Text and Clan
								local nametext = ""..colorname..""..(np.name)..""
								if nametagclan.value and np.HMclan
									nametext = "\x8C"..(np.HMclan).." "..colorname..""..(np.name)..""
								end	
								
								if nametagsmall.value or splitscreen > 1 then
									--Small Size
									v.drawString(iconx+namex+4, namey-7, nametext, splitflags|transtag|V_ALLOWLOWERCASE, "small")
									
									--HpMod
									if (hpmod and hpmod.running) then
										v.drawString(namex+4, namey-12, "\x8D"..(np.hpmod.hp).."%", splitflags|transtag, "small")
											
									--ReStat
									elseif (nametagstats.value and np.HMRs) or nametagstats.value == 2 then
										v.drawString(namex+4, namey-12, "\x88s"..(np.kartspeed).."", splitflags|transtag, "small")
										v.drawString(namex+14, namey-12, "\x87w"..(np.kartweight).."", splitflags|transtag, "small")
										
									else
										if np.startag >= 12 
											v.drawString(namex+4, namey-12, "\x82************", splitflags|transtag, "small")
										elseif np.startag == 11 
											v.drawString(namex+4, namey-12, "\x82***********", splitflags|transtag, "small")
										elseif np.startag == 10 
											v.drawString(namex+4, namey-12, "\x82**********", splitflags|transtag, "small")
										elseif np.startag == 9 
											v.drawString(namex+4, namey-12, "\x82*********", splitflags|transtag, "small")
										elseif np.startag == 8 
											v.drawString(namex+4, namey-12, "\x82********", splitflags|transtag, "small")
										elseif np.startag == 7 
											v.drawString(namex+4, namey-12, "\x82*******", splitflags|transtag, "small")
										elseif np.startag == 6 
											v.drawString(namex+4, namey-12, "\x82******", splitflags|transtag, "small")
										elseif np.startag == 5 
											v.drawString(namex+4, namey-12, "\x82*****", splitflags|transtag, "small")
										elseif np.startag == 4 
											v.drawString(namex+4, namey-12, "\x82****", splitflags|transtag, "small")
										elseif np.startag == 3
											v.drawString(namex+4, namey-12, "\x82***", splitflags|transtag, "small")
										elseif np.startag == 2 
											v.drawString(namex+4, namey-12, "\x82**", splitflags|transtag, "small")
										elseif np.startag == 1 
											v.drawString(namex+4, namey-12, "\x82*", splitflags|transtag, "small")
										end
										
									end

								else
									--Normal Size
									v.drawString(iconx+namex+8, namey-14, nametext, splitflags|transtag|V_ALLOWLOWERCASE, "thin")

									--HpMod
									if (hpmod and hpmod.running) then
										v.draw(namex+8, namey-24, v.cachePatch("NTHP"), splitflags|transtag)
										v.drawString(namex+18, namey-23, "\x8D"..(np.hpmod.hp).."", splitflags|transtag, "left")
											
									--ReStat
									elseif (nametagstats.value and np.HMRs) or nametagstats.value == 2 then
										v.draw(namex+8, namey-24, v.cachePatch("NTSP"), splitflags|transtag)
										v.drawString(namex+17, namey-23, "\x88"..(np.kartspeed).."", splitflags|transtag, "left")
										v.draw(namex+28, namey-24, v.cachePatch("NTWH"), splitflags|transtag)
										v.drawString(namex+37, namey-23, "\x87"..(np.kartweight).."", splitflags|transtag, "left")
									
									else
										if np.startag >= 12
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+24, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+40, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
										elseif np.startag == 11
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+24, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+40, namey-23, "\x82***", splitflags|transtag, "left")
										elseif np.startag == 10
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+24, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+40, namey-23, "\x82**", splitflags|transtag, "left")
										elseif np.startag == 9
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+24, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+40, namey-23, "\x82*", splitflags|transtag, "left")
										elseif np.startag == 8
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.draw(namex+24, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
										elseif np.startag == 7
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+24, namey-23, "\x82***", splitflags|transtag, "left")
										elseif np.startag == 6
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+24, namey-23, "\x82**", splitflags|transtag, "left")
										elseif np.startag == 5
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
											v.drawString(namex+24, namey-23, "\x82*", splitflags|transtag, "left")
										elseif np.startag == 4
											v.draw(namex+8, namey-23, v.cachePatch("NTCRWN"), splitflags|transtag)
										elseif np.startag == 3
											v.drawString(namex+8, namey-23, "\x82***", splitflags|transtag, "left")
										elseif np.startag == 2
											v.drawString(namex+8, namey-23, "\x82**", splitflags|transtag, "left")
										elseif np.startag == 1
											v.drawString(namex+8, namey-23, "\x82*", splitflags|transtag, "left")
										end
										
									end
								end
							end
						end
					end
				end
			end
		end
		if nametagdebug.value
			v.drawString(12,125, "Nametag Show: "..tagnum.."/"..nametagcap.value.."",V_ALLOWLOWERCASE|V_SNAPTOLEFT,"thin")
		end
	end
		
	-- flush table
	if #splitplayers > splitscreen
		splitplayers = {}
	end
end
hud.add(TagNames)